Attribute VB_Name = "CryptMod"
Public FicSource$               'Fichier source
Public FicClef$                 'Fichier clef
Public FicSourceC$              'Fichier source (sans rpertoire)
Public FicClefC$                'Fichier clef (sans rpertoire)
Public FicDestination$          'Fichier destination
Public FicDestinationC$         'Fichier destination (sans rpertoire)
Public RepDestination$          'Rpertoire destination
Public Limit As Byte            'Limiter  128 bits=1 sinon=0
Public CryptNom As Byte         'Crypter le nom=1 sinon=0
Public Decrypt As Byte          '=0 Crypter =1 Dcrypter
Public TailleOct As Long        'Taille en Octet
Public TailleAff$               'Taille traduite en Ko Mo
Public Fichier$                 'Fichier de travail
Public Existe As Byte           '=0 inexistant =1 Ok
Public TailleSource As Long     'Taille du fichier source
Public TailleClef As Long       'Taille du fichier clef
Public OldXor(5) As Byte        'Tableau des 5 derniers octets de clef
Public InitOldXor As Byte       'Valeur par dfaut d'initialisation du tableau des 5 derniers octets de clefs
Public ComptXor As Byte         'Compteur d'octet de clef
Public ComptLimit As Long       'Compteur de fin de clef
Public TailleDec As Long        'Taille en plus pour dcryptage
Public BoucClef As Long         'Nb de fois que la clef boucle
Public FinClefFix As Long       'Longueur du fichier clef +1 (valeur fixe)
Public FinClef As Long          'Longueur du fichier clef (valeur variable)
Public FinFic As Long           'Fin du fichier clef +1
Public Const Header = 12288     'Lire les donnes du fichier clef  partir de 12288 octets (12 ko)
Public msg$                     'Messages d'infos
Public Creannule As Byte        'Temoin d'annulation =0 OK  =1 annulation
Public boucl As Long            'Variable de boucle
Public Chrono As Byte           'Active le timer =0   Dsactive le timer =0   (pour affichage progression)
Public TailleTrav As Long       'Taille du fichier source - header
Public Path$                    'Rpertoire courant
Public Declare Function ShellExecuteA Lib "shell32" (ByVal hwnd As Long, ByVal LPFile As String, ByVal PathFile As String, ByVal Other As String, ByVal Other2 As String, ByVal Param As Long) As Long



' **********************************

' Dmarrage de CryptXor
' Version 1.0b du 13/04/2006
' Programme HippoSys / Thierry LEBEC

' **********************************


Sub Main()

On Error GoTo ErreurDisk

Path$ = CurDir$ + "\": If Right$(Path$, 2) = "\\" Then Path$ = Left$(Path$, Len(Path$) - 1)

Chrono = 0
Limit = 0
CryptNom = 1

CryptFrm.Height = CryptFrm.Height - 550
CryptFrm.Show

Exit Sub


'intercepte les erreurs disques
ErreurDisk:
rep = MsgBox(Err.Description, 53, "Erreur !")
Select Case rep
    Case 4
    Resume
    Case 2
    Resume Next
End Select

End Sub

Sub Crypter()

' Crypter / Dcrypter (Decrypt=0 Crypter / Decrypt=1 Dcrypter)

Creannule = 0

FicSource$ = Trim$(CryptFrm.TextSource)
FicClef$ = Trim$(CryptFrm.TextClef)
RepDestination$ = Trim$(CryptFrm.TextDestination)

CryptFrm.TextInfos.Text = ""
msg$ = "Dbut le " + Str$(Date) + "  " + Str$(Time): GoSub MsgInfo
msg$ = "": GoSub MsgInfo

Fichier$ = FicSource$
Call Testfic
If Existe = 0 Then msg$ = "Erreur dans le nom du fichier source !": GoSub MsgInfo: Exit Sub
Call ExtrNom
FicSourceC$ = Fichier$
msg$ = "Fichier source : " + FicSourceC$: GoSub MsgInfo
msg$ = "Taille du fichier source : " + TailleAff$: GoSub MsgInfo
msg$ = "": GoSub MsgInfo
TailleSource = TailleOct

Fichier$ = FicClef$
Call Testfic
If Existe = 0 Then msg$ = "Erreur dans le nom du fichier clef !": GoSub MsgInfo: Exit Sub
Call ExtrNom
FicClefC$ = Fichier$
msg$ = "Fichier clef : " + FicClefC$: GoSub MsgInfo
msg$ = "Taille du fichier clef : " + TailleAff$: GoSub MsgInfo
msg$ = "": GoSub MsgInfo
TailleClef = TailleOct - Header + 1

If Right$(RepDestination$, 1) = "\" Then RepDestination$ = Left$(RepDestination$, Len(RepDestination$) - 1)
FicDestinationC$ = FicSourceC$
RepDestination$ = Trim$(RepDestination$)
FicDestination$ = RepDestination$ + "\" + FicSourceC$

Call TestValidFic 'tests divers sur fichiers
If Existe = 0 Then GoSub MsgInfo: Exit Sub

BoucClef = 1
ComptXor = 0

Dim mix As Byte 'octet crypt
Dim oldy As Byte 'octet prcdent
mix = 0
oldy = 0

Dim x As Byte 'octet source
Dim y As Byte 'octet de clef
Dim z As Byte 'octet de taille du nom de fichier
Dim OctPres As Byte 'octet de prsence de nom de fichier source <128 inclu ; >127 non inclu

Open FicClef$ For Random As #1 Len = 1: Get #1, Header - 1, InitOldXor 'ouverture fichier clef + lecture octet de clef (initialisation)
For i = 1 To 5: OldXor(i) = InitOldXor: Next 'initialisation tableau des derniers octets utiliss

Open FicSource$ For Random As #2 Len = 1 'ouverture fichier source

If Decrypt = 0 Then GoTo ProgCrypt


'**********
'Dcrypter
'**********
FinClefFix = TailleClef 'Longueur de la Clef
FinFic = TailleClef + 1 'Longueur de la Clef +1
If Limit = 1 And FinClefFix > 16 Then FinClefFix = 16 'Si limite 128 bits
FinClefFix = FinClefFix + 1 'Longueur du fichier Clef+1
FinClef = FinClefFix
ComptLimit = 0
TailleDec = 1

Get #2, , y 'lecture octet source
If y > 127 Then FicDestinationC$ = FicSourceC$: msg$ = "Nom de fichier NON inclu": GoSub MsgInfo: GoTo CryptFichierDec 'nom de fichier non inclu
msg$ = "Nom de fichier inclu": GoSub MsgInfo
FicDestinationC$ = ""
Get #1, , x 'lecture octet de clef
Get #2, , y 'lecture octet source
mix = oldy Xor x Xor y: oldy = y
z = mix 'taille du nom de fichier
TailleDec = z + 2
ComptLimit = 1
ComptXor = 1
OldXor(1) = x

'Dcrypter nom du fichier

For boucl = 1 To z 'dbut de boucle sur le nb d'octets du nom de fichier  dcrypter

Get #2, , y 'lecture octet nom de fichier

ignorer3:
ComptLimit = ComptLimit + 1: If ComptLimit = FinClef Or ComptLimit = FinFic Then ComptLimit = 1: FinClef = FinClefFix:  Get #1, Header - 1, x: BoucClef = BoucClef + 1 'si fin de clef ou de fichier alors boucle au debut de fichier
Get #1, , x 'lecture octet de clef

If x = OldXor(1) Or x = OldXor(2) Or x = OldXor(3) Or x = OldXor(4) Or x = OldXor(5) Then FinClef = FinClef + 1: GoTo ignorer3 'si octet dj utilis au cours des 5 derniers octets cods alors ignorer

ComptXor = ComptXor + 1: If ComptXor = 6 Then ComptXor = 1 'nouvelle position dans le tableau des 5 derniers octets utilis

OldXor(ComptXor) = x 'nouvel octet dans le tableau des 5 derniers utiliss
mix = oldy Xor x Xor y: oldy = y
FicDestinationC$ = FicDestinationC$ + Chr$(mix) 'dcryptage octet de nom de fichier

Next boucl 'fin de boucle sur le nb d'octets du fichier source

rep = MsgBox("Le nom de fichier est-il correct ?" + Chr$(13) + Chr$(10) + FicDestinationC$, vbYesNo + vbQuestion + vbDefaultButton1, "Nom de fichier inclu")
If rep = 7 Then msg$ = "": GoSub MsgInfo: msg$ = "Le nom du fichier est incorrect : abandon": GoSub MsgInfo: GoTo termin

CryptFichierDec:
FicDestination$ = RepDestination$ + "\" + FicDestinationC$

Call TestficDes
If Existe = 0 Then GoSub MsgInfo: Close: Exit Sub

Open FicDestination$ For Output As #3 'ouverture fichier destination

GoTo CryptFichier


'**********
'Crypter
'**********

ProgCrypt:
Open FicDestination$ For Output As #3 'ouverture fichier destination

FinClefFix = TailleClef 'Longueur de la Clef
FinFic = TailleClef + 1 'Longueur de la Clef +1
If Limit = 1 And FinClefFix > 16 Then FinClefFix = 16 'Si limite 128 bits
FinClefFix = FinClefFix + 1 'Longueur du fichier Clef+1
FinClef = FinClefFix
ComptLimit = 0
TailleDec = 0

Randomize (Time) 'melange du "hazard"
OctPres = Int(Rnd * 128) 'nom de fichier inclu
If CryptNom = 0 Then OctPres = OctPres + 128 'nom de fichier non inclu
Print #3, Chr$(OctPres); 'criture octet de prsence
If CryptNom = 0 Then GoTo CryptFichier 'si fichier non inclu, passer  la suite



'Crypter nom du fichier source

y = Len(FicSourceC$) 'Taille nom de fichier source
Get #1, , x 'lecture octet de clef
mix = mix Xor x Xor y 'octet crypt
Print #3, Chr$(mix); 'criture octet crypt
ComptLimit = 1
ComptXor = 1
OldXor(1) = x

For boucl = 1 To Len(FicSourceC$) 'dbut de boucle sur le nb d'octets du fichier source

y = Asc(Mid$(FicSourceC$, boucl, 1)) 'lecture octet nom de fichier source

ignorer:
ComptLimit = ComptLimit + 1: If ComptLimit = FinClef Or ComptLimit = FinFic Then ComptLimit = 1: FinClef = FinClefFix:  Get #1, Header - 1, x: BoucClef = BoucClef + 1 'si fin de clef ou de fichier alors boucle au debut de fichier
Get #1, , x 'lecture octet de clef

If x = OldXor(1) Or x = OldXor(2) Or x = OldXor(3) Or x = OldXor(4) Or x = OldXor(5) Then FinClef = FinClef + 1: GoTo ignorer 'si octet dj utilis au cours des 5 derniers octets cods alors ignorer

ComptXor = ComptXor + 1: If ComptXor = 6 Then ComptXor = 1 'nouvelle position dans le tableau des 5 derniers octets utilis

OldXor(ComptXor) = x 'nouvel octet dans le tableau des 5 derniers utiliss
mix = mix Xor x Xor y 'octet crypt
Print #3, Chr$(mix); 'criture octet crypt

Next boucl 'fin de boucle sur le nb d'octets du fichier source
msg$ = "Nom du fichier source crypt. Possibilit de renommer le fichier destination et d'en rcuprer le nom d'origine lors du dcryptage": GoSub MsgInfo
msg$ = "": GoSub MsgInfo


'**********
'Crypter/Dcrypter fichier source
'**********

CryptFichier:
msg$ = "Fichier Destination : " + FicDestinationC$: GoSub MsgInfo
msg$ = "": GoSub MsgInfo
msg$ = "Dbut du cryptage": If Decrypt = 1 Then msg$ = "Dbut du dcryptage"
GoSub MsgInfo

Chrono = 1
CryptFrm.ShapeProg.Width = 0
CryptFrm.LabelPourcent = "0%"
CryptFrm.WindowState = 0
CryptFrm.Height = CryptFrm.Height + 550
TailleTrav = TailleSource - TailleDec
'msgBox "tailletrav : " + Str$(TailleTrav) + "          taillesource : " + Str$(TailleSource) + "           tailledec : " + Str$(TailleDec)
For boucl = 1 To TailleTrav 'dbut de boucle sur le nb d'octets du fichier source

Get #2, , y 'lecture octet source

ignorer2:
ComptLimit = ComptLimit + 1: If ComptLimit = FinClef Or ComptLimit = FinFic Then ComptLimit = 1: FinClef = FinClefFix:  Get #1, Header - 1, x: BoucClef = BoucClef + 1 'si fin de clef ou de fichier alors boucle au debut de fichier
Get #1, , x 'lecture octet de clef

If x = OldXor(1) Or x = OldXor(2) Or x = OldXor(3) Or x = OldXor(4) Or x = OldXor(5) Then FinClef = FinClef + 1: GoTo ignorer2 'si octet dj utilis au cours des 5 derniers octets cods alors ignorer

ComptXor = ComptXor + 1: If ComptXor = 6 Then ComptXor = 1 'nouvelle position dans le tableau des 5 derniers octets utilis

OldXor(ComptXor) = x 'nouvel octet dans le tableau des 5 derniers utiliss

If Decrypt = 0 Then mix = mix Xor x Xor y Else mix = oldy Xor x Xor y: oldy = y 'octet crypt/dcrypt

Print #3, Chr$(mix); 'criture octet crypt

DoEvents: If Creannule = 1 Then Close: Kill FicDestination$: msg$ = "": GoSub MsgInfo: msg$ = "Annulation": GoSub MsgInfo: CryptFrm.WindowState = 0: CryptFrm.Height = CryptFrm.Height - 550: GoTo termin

Next boucl 'fin de boucle sur le nb d'octets du fichier source


Close
msg$ = "": GoSub MsgInfo
msg$ = "C": If Decrypt = 1 Then msg$ = "Dc"
msg$ = msg$ + "ryptage du fichier termin avec succs !"
GoSub MsgInfo
msg$ = "": GoSub MsgInfo
msg$ = "Ce fichier est inviolable (un seul passage des donnes du fichier Clef)"
If BoucClef > 1 Then msg$ = "Ce fichier n'est PAS inviolable (" + Trim$(Str$(BoucClef)) + " passages des donnes du fichier Clef)"
GoSub MsgInfo
CryptFrm.WindowState = 0
CryptFrm.Height = CryptFrm.Height - 550


termin:
Chrono = 0
CryptFrm.Caption = "CryptXor v1.0b"
Close
msg$ = "": GoSub MsgInfo
msg$ = "Fin le " + Str$(Date) + "  " + Str$(Time): GoSub MsgInfo

Exit Sub


MsgInfo:
CryptFrm.TextInfos.Text = CryptFrm.TextInfos.Text + msg$ + Chr$(13) + Chr$(10)
CryptFrm.TextInfos.Refresh
Return

End Sub

'Tests divers de validit

Sub TestValidFic()

Existe = 1

'tester si fichier source <> destination
msg$ = "Le fichier source doit tre diffrent du fichier destination !"
If UCase$(FicSource$) = UCase$(FicDestination$) Then Existe = 0: Exit Sub

'tester si fichier source <> clef
msg$ = "Le fichier source doit tre diffrent du fichier clef !"
If UCase$(FicSource$) = UCase$(FicClef$) Then Existe = 0: Exit Sub

'tester fichier destination non existant
If Decrypt = 1 Then GoTo testsuivant
On Error GoTo Absent
Open FicDestination$ For Input As #1 Len = 1
Close
rep = MsgBox("Ecraser ?" + Chr$(13) + Chr$(10) + FicDestination$, vbYesNo + vbExclamation + vbDefaultButton1, "Le nom du fichier destination existe dj !")
If rep = 7 Then msg$ = "Le fichier destination existe dj : abandon": Existe = 0: Exit Sub
GoTo testsuivant
Absent:
Close: Resume testsuivant
Exit Sub

'tester rpertoire destination non existant
testsuivant:
msg$ = "Erreur dans le nom du rpertoire destination !"
On Error GoTo Absent2
ChDir RepDestination$
GoTo testsuivant2
Absent2:
Resume Ok2
Ok2:
Existe = 0
On Error GoTo ErreurDisk
Exit Sub

'tester si fichier clef valide
testsuivant2:
msg$ = "Le fichier clef est incorrect ! Il ne contient pas assez de donnes diffrentes !"

Dim x As Byte 'octet source
FinClefFix = TailleClef 'Longueur de la Clef
FinFic = TailleClef + 1 'Longueur de la Clef +1
If Limit = 1 And FinClefFix > 16 Then FinClefFix = 16 'Si limite 128 bits
FinClefFix = FinClefFix + 1 'Longueur du fichier Clef+1
FinClef = FinClefFix
ComptLimit = 0
ComptXor = 0
For i = 1 To 5: OldXor(i) = InitOldXor: Next 'initialisation tableau des derniers octets utiliss

On Error GoTo ErreurDisk
Open FicClef$ For Random As #1 Len = 1 ' Get #1, Header - 1, x
TailleOct = LOF(1)
If TailleOct < Header + 5 Then Existe = 0: GoTo fintest
Get #1, Header - 1, x

boucltest:

ignorer:
ComptLimit = ComptLimit + 1: If ComptLimit = FinClef Or ComptLimit = FinFic Then Existe = 0: GoTo fintest
Get #1, , x 'lecture octet de clef
If x = OldXor(1) Or x = OldXor(2) Or x = OldXor(3) Or x = OldXor(4) Or x = OldXor(5) Then FinClef = FinClef + 1: GoTo ignorer
ComptXor = ComptXor + 1: If ComptXor = 6 Then GoTo fintest
OldXor(ComptXor) = x
GoTo ignorer

fintest:
Close
Exit Sub


'intercepte les erreurs disques
ErreurDisk:
rep = MsgBox(Err.Description, 53, "Erreur !")
Select Case rep
    Case 4
    Resume
    Case 2
    Resume Next
End Select

End Sub

Sub TestficDes()

'tester fichier destination non existant
On Error GoTo Absent
Open FicDestination$ For Input As #3 Len = 1
Close #3
rep = MsgBox("Ecraser ?" + Chr$(13) + Chr$(10) + FicDestination$, vbYesNo + vbExclamation + vbDefaultButton1, "Le nom du fichier destination existe dj !")
If rep = 7 Then msg$ = "Le fichier destination existe dj : abandon": Existe = 0: Exit Sub
GoTo term
Absent:
Close #3: Resume term
Exit Sub

term:
On Error GoTo ErreurDisk
Exit Sub

'intercepte les erreurs disques
ErreurDisk:
rep = MsgBox(Err.Description, 53, "Erreur !")
Select Case rep
    Case 4
    Resume
    Case 2
    Resume Next
End Select

End Sub

'Test si fichier valide + extraction taille du fichier

Sub Testfic()

Existe = 1
On Error GoTo Absent
Open Fichier$ For Input As #1
TailleOct = LOF(1)
Close
Call TailleOctet
Exit Sub


Absent:
Close: Resume Ok2
Ok2:
Existe = 0
On Error GoTo ErreurDisk
Exit Sub


'intercepte les erreurs disques
ErreurDisk:
rep = MsgBox(Err.Description, 53, "Erreur !")
Select Case rep
    Case 4
    Resume
    Case 2
    Resume Next
End Select

End Sub

'Extrait le nom du fichier (enlve rpertoire)

Sub ExtrNom()
trouv = 0
For i = Len(Fichier$) To 1 Step -1
lett$ = Mid$(Fichier$, i, 1): If lett$ = "\" Or lett$ = ":" Then trouv = i: Exit For
Next
Fichier$ = Trim$(Right$(Fichier$, Len(Fichier$) - i))

End Sub

' Converti la taille en Ko / Mo

Sub TailleOctet()
If TailleOct >= 1073741824 Then TailleAff$ = Format(TailleOct / 1073741824, "#.## go"): Exit Sub
If TailleOct >= 1048576 Then TailleAff$ = Format(TailleOct / 1048576, "#.## mo"): Exit Sub
If TailleOct >= 1024 Then TailleAff$ = Format(TailleOct / 1024, "#.## ko"): Exit Sub
TailleAff$ = LTrim$(Str(TailleOct)) + " octets"
End Sub

' Bloque les controles

Sub Bloque()

CryptFrm.TextSource.Enabled = False
CryptFrm.TextClef.Enabled = False
CryptFrm.TextDestination.Enabled = False
CryptFrm.CheckNom.Enabled = False
CryptFrm.CheckLimit.Enabled = False
CryptFrm.CommandCrypt.Enabled = False
CryptFrm.CommandDecrypt.Enabled = False
CryptFrm.ImageClef.Enabled = False
CryptFrm.ImageDestination.Enabled = False
CryptFrm.ImageCrypt.Enabled = False
CryptFrm.CommandQuit.Caption = "Annuler"
CryptFrm.CommandQuit.ToolTipText = "Abandonne le (d)cryptage en cours"

End Sub

' Dbloque les controles

Sub Debloque()

CryptFrm.TextSource.Enabled = True
CryptFrm.TextClef.Enabled = True
CryptFrm.TextDestination.Enabled = True
CryptFrm.CheckNom.Enabled = True
CryptFrm.CheckLimit.Enabled = True
CryptFrm.CommandCrypt.Enabled = True
CryptFrm.CommandDecrypt.Enabled = True
CryptFrm.ImageClef.Enabled = True
CryptFrm.ImageDestination.Enabled = True
CryptFrm.ImageCrypt.Enabled = True
CryptFrm.CommandQuit.Caption = "Quitter"
CryptFrm.CommandQuit.ToolTipText = "Ferme le logiciel"

End Sub



